#!/usr/local/bin/perl
#### եܼץ mkidx.pl V4.00
#### Copyright 1998-2005 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### History: 
#### 2005/04/22 V4.00 С󳫻ϡ
#### 2004/07/21 V3.01 ƥΥڡʸڤΤƤ
####                  ԤƤ
#### 2004/07/20 V3.01 ޥ¸ߤƤʤΥϥ󥯤
####                  ɽʤ褦
#### 2004/05/14 V3.00 С󳫻ϡ
#### 2000/09/23 V2.11 

require "libgns.pl";


if ($#ARGV+1 < 1) {
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	$year += 1900;
}
else {
	$year = $ARGV[0];
}

&Setup();
&Setup_DAYS( $year );

&AnalyzeIndex( $year );
&MakeCategoryIndex( $year );
&MakeYearIndex( $year );

&Finish();
exit;

0;

########################################################################
### ǥåѲ
#

sub AnalyzeIndex {
	local( $year ) = @_;
	local( $i, $j, $wday, $month, $day, $part, $topic, $category, $daycategory, $fin, $line, $ncw, @cw, $cwc, $cls, $cmd );
	local( $FIN );

	$NCATEGORYWORD = 0;
	$NTITLE = 0;

	# ǯʬγפ
	for ( $month=1; $month<=12; $month++ ) {
		&YMD2DAYS( $year, $month, 1 );
		$wday = $WDAY;
		for ( $day=1; $day<=$DAYS[$month]; $day++, $wday = ($wday+1) % 7 ) {
			$part = 0;
			if ( $day > 10 ) {
				$part++;
			}
			if ( $day > 20 ) {
				$part++;
			}
			$NDAYTITLE[$NTITLE] = 0;
			$topic = '';
			$fin = &MakeMasterFileName( $year, $month, $day );
			$DAYEXIST{$year,$month,$day} = 0;
			next if ( !(-e $fin) ) ;
			$DAYEXIST{$year,$month,$day} = 1;
			$cmd = $NKFCMD . ' -e ' . $fin . "|";
			$FIN = $cmd; open( FIN ) || next;
			while ( $line = <FIN> ) {
				$line =~ s/[\012\015]+//;
				if ( $line =~ s/^\@topic[ \t]+// ) {
					$topic = &Replace( $line, $year, $month, $part, $day );
					next;
				}
				if ( $line =~ s/^\@title[ \t]+// ) {
					$CATEGORY[$NDAYTITLE[$NTITLE]] = '';
					$TITLE[$NDAYTITLE[$NTITLE]++] = &Replace( $line, $year, $month, $part, $day );
					next;
				}
				if ( $line =~ s/^\@category[ \t]+// ) {
					$category = &Replace( $line, $year, $month, $part, $day );
					if ( $NDAYTITLE[$NTITLE] > 0 ) {
						$CATEGORY[$NDAYTITLE[$NTITLE]-1] = $category;
					}
					next;
				}
			}
			close( FIN );
			if ( $NDAYTITLE[$NTITLE] || $topic ne '' ) {
				$DAYNTITLE[$NTITLE] = $NDAYTITLE[$NTITLE];
				$DAYTOPIC[$NTITLE] = $topic;
				$DAYLINK[$NTITLE] = sprintf( '%d %d %d %d %d %d', $year, $month, $part, $day, 0, $wday );
				for ( $i=0; $i<$NDAYTITLE[$NTITLE]; $i++ ) {
					$DAYTITLE{$NTITLE, $i} = $TITLE[$i];
					$DAYCATEGORY{$NTITLE, $i} = $CATEGORY[$i];
#					if ( $CATEGORY[$i] ne '' ) {
						$ncw = ( @cw = split( ",", $CATEGORY[$i] ));
						if ( $ncw == 0 ) {
							$ncw = 1;
							$cw[0] = "";
						}
						for ( $j=0; $j<$ncw; $j++ ) {
							$cw[$j] =~ s/^[ \t]+//;
							$cw[$j] =~ s/[ \t]+$//;
							$cwc = $CATEGORYWORDCOUNT{$cw[$j]} + 0;
							if ( $cwc == 0 ) {
								$CATEGORYWORD[$NCATEGORYWORD] = $cw[$j];
								$NCATEGORYWORD++;
							}
							$CATEGORYWORDLINK{$cw[$j], $cwc} = sprintf( '%d %d %d %d %d %d', $year, $month, $part, $day, $i+1, $wday );
							$CATEGORYWORDTITLE{$cw[$j], $cwc} = $TITLE[$i];
							$CATEGORYWORDCOUNT{$cw[$j]}++;
						}
#					}
				}
				$NTITLE++;
			}
		}
	}

	# ƥΥȥꥹȤ
	for ( $i=0; $i<$NCATEGORYWORD; $i++ ) {
		$CATEGORYSORTIDX[$i] = $i;
	}
	for ( $i=0; $i<$NCATEGORYWORD-1; $i++ ) {
		for ( $j=$i+1; $j<$NCATEGORYWORD; $j++ ) {
			if ( $CATEGORYWORD[$CATEGORYSORTIDX[$i]] gt $CATEGORYWORD[$CATEGORYSORTIDX[$j]]) {
				$t = $CATEGORYSORTIDX[$i];
				$CATEGORYSORTIDX[$i] = $CATEGORYSORTIDX[$j];
				$CATEGORYSORTIDX[$j] = $t;
			}
		}
	}
	for ( $i=0; $i<$NCATEGORYWORD; $i++ ) {
		$CATEGORYWORD2IDX{$CATEGORYWORD[$CATEGORYSORTIDX[$i]]} = $i+1;
	}
}

########################################################################
### ȥꥹȽ
#
sub PutTitleList {
	local( $FOUT, $year ) = @_;
	local( $t, @link, $month, $part, $day, $titleno, $wday, $topic, $lastmonth );

	$lastmonth = 0;
	for ( $t=0; $t<$NTITLE; $t++ ) {
		@link = split(' ', $DAYLINK[$t] );
		$month = $link[1];
		$part = $link[2];
		$day = $link[3];
		$titleno = $link[4];
		$wday = $link[5];
		$topic = $DAYTOPIC[$t];

		if ( $lastmonth != $month ) {
			if ( $lastmonth > 0 ) {
				print $FOUT "</TABLE></DD></DL><HR>\n";
			}
			printf( $FOUT "<DL class=\"idxlist\"><DT><DIV class=\"idxlist_month\"><B><A name=\"%02d\">[%d/%02d]</A></B></DIV></DT>\n",
			  $month, $year, $month
			);
			print $FOUT "<DD><TABLE class=\"idxlist_titles\" border=\"0\">";
			$lastmonth = $month;
		}

		$cls = 'weekday';
		if ( $wday == 0 ) {
			$cls = 'sunday';
		}
		if ( $wday == 6 ) {
			$cls = 'saturday';
		}
		printf( $FOUT "<TR><TD valign=\"top\" class=\"idxlist_date_%s\">\n", $cls );
		printf( $FOUT "<DIV nowrap><A href=\"%d%02d%s.html#%s%02d\">%02d</A>(%s)</DIV>\n",
		  $year, $month, $PARTS[$part], $ANCHOR, $day, $day, $WDAYS[$wday]
		);

		print $FOUT "</TD><TD valign=\"top\" class=\"idxlist_title\">\n";

		if ( $topic ne '' ) {
			print $FOUT "<DIV class=\"idxlist_topic\">" . $topic . "</DIV>\n";
		}

		for ( $i=0; $i<$DAYNTITLE[$t]; $i++ ) {
			printf( $FOUT "<A href=\"%04d%02d%s.html#%s%02d%02d\">%s</A>",
			  $year, $month, $PARTS[$part], $ANCHOR, $day, $i+1, $DAYTITLE{$t, $i}
			);
			if ( $DAYCATEGORY{$t, $i} ne '' ) {
				$s = &MakeCategoryLinkStrings( $year, $DAYCATEGORY{$t, $i} );
				printf( $FOUT " <SPAN class=\"category\">(%s)</SPAN>", $s );
			}
			if ( $i < $DAYNTITLE[$t]-1 ) {
				print $FOUT " / \n";
			}
		}
		print $FOUT "</TD></TR>\n";
	}
	if ( $lastmonth > 0 ) {
		print $FOUT "</TABLE></DD></DL><HR>\n";
	}
}

########################################################################
### 
#
sub PutCalendar {
	local( $FOUT, $year ) = @_;
	local( $y, $x, $month, $cx, $cy, $cls, $day );

	print $FOUT "<DIV align=\"right\" class=\"idxlist_calendar\"><TABLE class=\"idxlist_caltbl\" border=\"1\">\n";
	for ( $y=0; $y<12; $y++ ) {
		# إå
		print $FOUT "<TR>\n";
		for ( $x=0; $x<1; $x++ ) {
			$month = $y*1 + $x+1;
			printf( $FOUT "<TD align=\"center\"><A HREF=\"%04d%02da.html\">%04d/%02d</A></TD>",
			  $year, $month, $year, $month
			);
		}
		print $FOUT "</TR><TR>\n";
		for ( $x=0; $x<1; $x++ ) {
			$month = $y*1 + $x+1;
			&YMD2DAYS( $year, $month, 1 );
			print $FOUT "<TD>\n";

			# 
			print $FOUT " <TABLE border=\"0\">\n";
			print $FOUT "<TR>";
			for ( $cx=0; $cx<7; $cx++ ) {
				$cls = 'weekday';
				if ( $cx == 0 ) {
					$cls = 'sunday';
				}
				if ( $cx == 6 ) {
					$cls = 'saturday';
				}
				printf( $FOUT "<TD class=\"%s\" align=\"right\"><FONT size=\"-2\" class=\"cal\">%s</FONT></TD>\n",
				  $cls, $WDAYS[$cx]
				);
			}
			print $FOUT "</TR>\n";

			# 
			$day = 0;
			for ( $cy=0; $cy<6; $cy++ ) {
				if ( $day > $DAYS[$month] ) {
					next;
				}
				print $FOUT " <TR>\n";
				for ( $cx=0; $cx<7; $cx++ ) {
					$cls = 'weekday';
					if ($cx == 0) {
						$cls = 'sunday';
					}
					if ($cx == 6) {
						$cls = 'saturday';
					}
					if ($day == 0) {
						if ($cx == $WDAY) { #???
							$day = 1;
						}
					}
					$part = 0;
					if ($day > 10) {
						$part++;
					}
					if ($day > 20) {
						$part++;
					}
					if ( ($day > 0) && ($day <= $DAYS[$month]) ) {
						if ( $DAYEXIST{$year,$month,$day} == 1 ) {
							printf( $FOUT "<TD class=\"%s\" align=\"right\"><FONT size=\"-2\" class=\"cal\"><A href=\"%d%02d%s.html#%s%02d\">%d</A></FONT></TD>\n",
							  $cls, $year, $month, $PARTS[$part], $ANCHOR, $day, $day
							);
						} else {
							printf( $FOUT "<TD class=\"%s\" align=\"right\"><FONT size=\"-2\" class=\"cal\">%d</FONT></TD>\n",
							  $cls, $day
							);
						}
						$day++;
					} else {
						printf( $FOUT "<TD class=\"weekday\"></TD>\n", $cls, $day );
					}
				}
				print $FOUT "</TR>\n";
			}

			print $FOUT " </TABLE>\n";
			print $FOUT "</TD>\n";
		}
		print $FOUT "</TR>\n";
	}
	print $FOUT "</TABLE></DIV>\n";
}

########################################################################
### ǯǥåե
#
sub MakeYearIndex {
	local( $year ) = @_;
	local( $fout );
	local( $umaskback );
	local( $FOUT );

	$fout = sprintf( "|" . $NKFCMD . ' ' . $NKFCODE . '>' . $PUTDIR . $SLASH . '%04d.html', $year );
	$umaskback = umask( oct($DIARY_PUT_PERM) ^ 0666 );
	$FOUT = $fout; open( FOUT ) || die "cannot open [$fout].";

	# إåʬ
	&CatFile( FOUT, $KEEPDIR . $SLASH . $INDEXHEADERNAME, $year, 0, 0 );
	print FOUT "<TABLE class=\"listtbl\" border=\"0\"><TR><TD valign=top>\n";

	# ȥꥹ
	&PutTitleList( FOUT, $year );

	print FOUT "</TD><TD valign=top>\n";

	# 
	&PutCalendar( FOUT, $year );

	print FOUT "</TD><TR></TABLE>\n";

	# եåʬ
	&CatFile( FOUT, $KEEPDIR . $SLASH . $INDEXFOOTERNAME, $year, $month, $part );
	close( FOUT );
	umask( $umaskback );
}

########################################################################
### ƥꥤǥåե
#
sub MakeCategoryIndex {
	local( $year ) = @_;
	local( $fout, $i, $i2, $j, $ci, $cwd, $cwdurl, $cwdprint, $cwdnull, $cwc, @link );
	local( $umaskback );
	local( $FOUT );

	$fout = sprintf( "|" . $NKFCMD . ' ' . $NKFCODE . '>' . $PUTDIR . $SLASH . '%04d_ca.html', $year );
	$umaskback = umask( oct($DIARY_PUT_PERM) ^ 0666 );
	$FOUT = $fout; open( FOUT ) || die "cannot open [$fout].";

	# إåʬ
	&CatFile( FOUT, $KEEPDIR . $SLASH . $CAINDEXHEADERNAME, $year, $month, $part );

	# ƥɰ
	$cwdnull = 0;
	if ( $CATEGORYWORD[$CATEGORYSORTIDX[0]] eq "" ) {
		$cwdnull = 1;
	}
	print FOUT "<OL class=\"categorywordlist\">\n";
	for ( $i2=0; $i2<$NCATEGORYWORD; $i2++ ) {
		if ( $cwdnull ) {
			$i = $i2+1;
			$i = 0 if ( $i == $NCATEGORYWORD );
		} else {
			$i = $i2;
		}
		$ci = $CATEGORYSORTIDX[$i];
		$cwd = $CATEGORYWORD[$ci];
		$cwdprint = $cwd;
		$cwdurl = &Encode2URL( $cwd, 'UTF8' );
		$cwdprint = "(no category)" if ( $cwdprint eq "" );
		printf( FOUT "<LI><A HREF=\"#W_%s\">%s (%d)</A></LI>\n",
		  $cwdurl, $cwdprint, $CATEGORYWORDCOUNT{$cwd}
		);
	}
	print FOUT "</OL>\n";
	print FOUT "<HR>\n";

	# ƥ̥ꥹ
	print FOUT "<DL class=\"categorylist\">\n";
	for ( $i2=0; $i2<$NCATEGORYWORD; $i2++ ) {
		if ( $cwdnull ) {
			$i = $i2+1;
			$i = 0 if ( $i == $NCATEGORYWORD );
		} else {
			$i = $i2;
		}
		$ci = $CATEGORYSORTIDX[$i];
		$cwd = $CATEGORYWORD[$ci];
		$cwc = $CATEGORYWORDCOUNT{$cwd};
		$cwdprint = $cwd;
		$cwdurl = &Encode2URL( $cwd, 'UTF8' );
		$cwdprint = "(no category)" if ( $cwdprint eq "" );
		printf( FOUT "<DT id=\"W%d\">%d. <A HREF=\"#W_%s\" NAME=\"W_%s\">%s (%d)</A></DT>\n",
		  $i2+1, $i2+1, $cwdurl, $cwdurl, $cwdprint, $cwc
		);
		print FOUT "<DD>\n";
		for ( $j=0; $j<$cwc; $j++ ) {
			@link = split( ' ', $CATEGORYWORDLINK{$cwd, $j} );
			printf( FOUT "<DIV>%04d/%02d/%02d(%s) : <A HREF=\"%04d%02d%s.html#%s%02d%02d\">%s</A></DIV>\n",
			  $link[0], $link[1], $link[3], $WDAYS[$link[5]], $link[0],
			  $link[1], $PARTS[$link[2]], $ANCHOR, $link[3], $link[4],
			  $CATEGORYWORDTITLE{$cwd, $j}
			);
		}
		print FOUT "</DD>\n";
	}
	print FOUT "</DL>\n";

	# եåʬ
	&CatFile( FOUT, $KEEPDIR . $SLASH . $CAINDEXFOOTERNAME, $year, $month, $part );
	close( FOUT );
	umask( $umaskback );
}

# [EOF]
